from Products.Silva.mangle import String

request = container.REQUEST

form = request.form
model = request.other['model']

if form.has_key('cancel_submit'):
    # hm, maybe we should use a javascript back instead ...
    request.RESPONSE.redirect(model.get_local_variant_url(model.get_default_language())+'/edit')
    return ''

if not form.has_key('language'):
    # this cannot happen anyway ...
    return context.tab_edit_create_variant(message_type='error',
                                           message='Please select a language.')

old_lang = form['language']
new_lang = model.get_selected_language()

if old_lang not in model.get_available_languages():
    # hmm ... could this ever happen ?
    return context.tab_edit_create_variant(message_type='error',
                                           message='Cannot create a variant for the language: %s.' % model.get_language_name(old_lang))

if new_lang not in model.get_supported_languages():
    # hmm ... could this ever happen?
    return context.tab_edit_create_variant(message_type='error',
                                           message='Cannot create a variant for the language: %s.' % model.get_language_name(new_lang))


if new_lang in model.get_available_languages():
    # hmm ... back button or reload or concurrent other request
    return context.tab_edit(message_type='error',
                            message='There is already a variant for the language %s.' % model.get_language_name(new_lang))

title = String.inputConvert(form.get('title',''))
if not title:
    return context.tab_edit_create_variant(message_type='error',
                            message='Please give the new language variant a title',
                            lang = new_lang)
    

model.create_language_variant(new_lang, old_lang)

# the new language should also be the current one (?)
model.set_title(title)#, lang=new_lang)

#
# we had separated manually the index title form the container title ..
# here is the place we have to pay for it:
if model.implements_container() and model.get_default() is not None \
       and model.check_for_language_awareness(model.get_default()) :
    model.get_default().set_title(title)


return context.tab_edit(message_type='feedback',
                        message='Created new language variant.')
