# zope
from Globals import InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Persistence import Persistent

# silva
from Products.Silva.helpers import add_and_edit
from Products.Silva import mangle
from Products.Silva.interfaces import IContainerPolicy
from Products.SilvaDocument.Document import Document
from Products.SilvaDocument.Document import DocumentVersion 

# silva local content
from interfaces import ILocalVersionedContent
from LocalVersionedContent import LocalVersionedContent

icon = 'www/silvadoc.gif'
addable_priority=-2
class LocalDocument(LocalVersionedContent, Document):

    __implements__ = (ILocalVersionedContent,)

    meta_type = 'Silva Local Document'

    _version_class = DocumentVersion

    def __init__(self, id, title, language):
        LocalDocument.inheritedAttribute('__init__')(self, id, title, language)
    
InitializeClass(LocalDocument)

manage_addLocalDocumentForm = PageTemplateFile("www/documentAdd.zpt", globals(),
                                               __name__='manage_addLocalDocumentForm')

def manage_addLocalDocument(self, id, title, REQUEST=None):
    """Add a Locale Document."""

    if not mangle.Id(self, id).isValid():
        return

    language = self.get_selected_language()
    object = LocalDocument(id, title, language=language)
    self._setObject(id, object)
    object = getattr(self, id)
    object._setupAfterAdd()
    object.get_editable().set_title(title)
    object.sec_update_last_author_info()
    
    add_and_edit(self, id, REQUEST)
    return ''


class SilvaLocalDocumentPolicy(Persistent):

    __implements__ = IContainerPolicy

    def createDefaultDocument(self, container, title):
        container.manage_addProduct['SilvaLocalContent'] \
                 .manage_addLocalDocument('index', title)
