# some helpers for nicer testing

from thread import get_ident
from Products.iHotfix import contexts, Context

from Products.SilvaLocalContent.util import AcceptLanguageFake

def set_current_request(request):
    # ugly helper to mangle in the request to the global mapping
    # maintained by Localizer / itools
    request.environ['PATH_INFO']='/'
    request.set('AcceptLanguage', AcceptLanguageFake('en'))

    contexts[get_ident()]=Context(request)


def assert_equal_elements(seq1, seq2):
    """ helper test, if two sequences contain the same elements
    even if in a different order
    """
    for x in seq1:
        if x not in seq2:
            raise AssertionError('%s not in sequence.\nexpected sequence: %s\ngot sequence %s' %\
                      (x, seq1, seq2))
    for y in seq2:
        if y not in seq1:
            raise AssertionError('%s too much in sequence.\nexpected sequence: %s\ngot sequence %s' %\
                      (y, seq1, seq2))
